<template>
  <div class="hello">
    <div class="field">
  <label class="label">Quartier prioritaire</label>
  <div class="control">
    <input class="input ismid"  type="text" placeholder="Saississez le code la zone" v-model="qpv" list="qpv"> 
  </div>
</div>
    <datalist id="qpv">
        <option value="QP067007">Quartier Prioritaire De Lingolsheim - Lingolsheim</option>
        <option value="QP051008">Walbaum - Reims</option>
        <option value="QP051001">Quartier Prioritaire Ouest - Châlons-en-Champagne</option>
        <option value="QP054018">Coeur De Ville - Tomblaine</option>
        <option value="QP051005">Orgeval - Reims</option>
        <option value="QP051009">Epinettes - Maladrerie - Chemin Des Bouchers - Reims</option>
        <option value="QP088001">Bitola - Épinal</option>
        <option value="QP088003">Le Haut Du Gras - Golbey</option>
        <option value="QP068005">Péricentre - Mulhouse</option>
        <option value="QP054012">La Californie - Jarville-la-Malgrange</option>
        <option value="QP054016">Haussonville - Les Nations - Vandoeuvre-les-Nancy, Nancy</option>
        <option value="QP067004">Quartiers Ouest - Bischheim, Schiltigheim</option>
        <option value="QP057019">Hauts De Vallières - Metz</option>
        <option value="QP057023">Quartier Saint-Eloy - Boileau-Pré Génie - Woippy, Metz</option>
        <option value="QP057009">Quartier Terrasses Des Provinces - Yutz</option>
        <option value="QP057010">Beausoleil - Sarreguemines</option>
        <option value="QP054005">Val Saint Martin - Mont-Saint-Martin</option>
        <option value="QP054008">Bois Le Prêtre - Procheville - Pont-à-Mousson</option>
        <option value="QP057011">Vieille Ville Et Ville Haute - Sarreguemines</option>
        <option value="QP052003">Quartier Neuf - Langres</option>
        <option value="QP057021">Sablon Sud - Metz</option>
        <option value="QP055001">Côte Sainte-Catherine - Bar-le-Duc</option>
        <option value="QP067013">Cronenbourg - Strasbourg</option>
        <option value="QP067016">Neuhof - Meinau - Strasbourg</option>
        <option value="QP068007">Quartier Brustlein - Mulhouse</option>
        <option value="QP057001">Quartier Saravis - Sarrebourg</option>
        <option value="QP054010">Niederbronn - Zola - Lunéville</option>
        <option value="QP054006">Quartier Les Mouettes - Champigneulles</option>
        <option value="QP067003">Saverne - Quartiers Est - Saverne</option>
        <option value="QP055003">Centre Verdun - Cité verte - Verdun</option>
        <option value="QP057003">Wiesberg Hommel - Forbach</option>
        <option value="QP057002">La Cité - Behren-lès-Forbach</option>
        <option value="QP054013">Les Provinces - Laxou</option>
        <option value="QP067001">Quartier Liberté - Bischwiller</option>
        <option value="QP068006">Drouot - Jonquilles - Mulhouse, Illzach</option>
        <option value="QP052004">Vert-Bois - Saint-Dizier</option>
        <option value="QP054009">Centre Ancien - Lunéville</option>
        <option value="QP008006">Torcy Centre - Sedan</option>
        <option value="QP055002">Planchettes - Verdun</option>
        <option value="QP057014">Cité Du Furst - Folschviller, Valmont</option>
        <option value="QP057007">Côte Des Roses - Thionville</option>
        <option value="QP057008">Quartier Saint Pierre - La Millaire - Thionville</option>
        <option value="QP057018">Bellecroix - Metz</option>
        <option value="QP057020">Borny - Metz</option>
        <option value="QP057022">La Patrotte - Metz-Nord - Metz</option>
        <option value="QP068010">Quartier Bel Air - Cernay</option>
        <option value="QP010009">Point Du Jour - Troyes</option>
        <option value="QP008008">Coeur De Vie - Rethel</option>
        <option value="QP088004">Le Rhumont - Remiremont</option>
        <option value="QP051012">Bernon - Épernay</option>
        <option value="QP088006">Kellermann - Saint-Dié-des-Vosges</option>
        <option value="QP088005">Saint Roch - L'Orme - Saint-Dié-des-Vosges</option>
        <option value="QP051004">Wilson - Maison Blanche - Chatillons - Reims</option>
        <option value="QP088002">La Justice - Épinal</option>
        <option value="QP051003">Croix Rouge - Reims</option>
        <option value="QP008002">Ronde Couture - Charleville-Mézières</option>
        <option value="QP008007">Le Lac - Centre Ancien - Sedan</option>
        <option value="QP057012">La Chapelle - Hombourg-Haut, Freyming-Merlebach</option>
        <option value="QP054001">Mouzimpré - Essey-lès-Nancy</option>
        <option value="QP057024">Les Chênes - Hombourg-Haut</option>
        <option value="QP057003">Wiesberg Hommel - Forbach</option>
        <option value="QP067011">Hautepierre - Strasbourg</option>
        <option value="QP057002">La Cité - Behren-lès-Forbach</option>
        <option value="QP054013">Les Provinces - Laxou</option>
        <option value="QP051010">Le Hamois - Vitry-le-François</option>
        <option value="QP008001">Manchester - Charleville-Mézières</option>
        <option value="QP008005">Torcy Cités - Sedan</option>
        <option value="QP055002">Planchettes - Verdun</option>
        <option value="QP057005">Quartier Rémelange - Fameck</option>
        <option value="QP067012">Koenigshoffen-Est - Strasbourg</option>
        <option value="QP067021">Murhof - Strasbourg</option>
        <option value="QP068002">Europe - Schweitzer - Colmar</option>
        <option value="QP057014">Cité Du Furst - Folschviller, Valmont</option>
        <option value="QP068010">Quartier Bel Air - Cernay</option>
        <option value="QP010004">Debussy - Pont-Sainte-Marie</option>
        <option value="QP010005">Maugout - Saint-André-les-Vergers</option>
        <option value="QP010006">Chartreux - Troyes</option>
        <option value="QP068003">Quartier Les Coteaux - Mulhouse</option>
        <option value="QP010007">Jules Guesde - Troyes</option>
        <option value="QP010008">Sénardes - Troyes</option>
        <option value="QP068004">Quartier De Bourtzwiller - Mulhouse</option>
        <option value="QP010009">Point Du Jour - Troyes</option>
        <option value="QP051011">Rome Saint Charles - Vitry-le-François</option>
        <option value="QP008008">Coeur De Vie - Rethel</option>
        <option value="QP010010">Quartier Des Lumières - Alfred Boucher - Romilly-sur-Seine</option>
        <option value="QP088006">Kellermann - Saint-Dié-des-Vosges</option>
        <option value="QP051004">Wilson - Maison Blanche - Chatillons - Reims</option>
        <option value="QP054002">Gouraincourt - Remparts - Longwy</option>
        <option value="QP008004">La Couronne - Charleville-Mézières</option>
        <option value="QP008003">La Houillère - Charleville-Mézières</option>
        <option value="QP057012">La Chapelle - Hombourg-Haut, Freyming-Merlebach</option>
        <option value="QP057015">Carrière Wehneck - Saint-Avold</option>
        <option value="QP010001">Gare - Troyes</option>
        <option value="QP054014">Plateau De Haye - Champ Le Boeuf - Maxéville, Laxou</option>
        <option value="QP057004">Bellevue - Forbach</option>
        <option value="QP057024">Les Chênes - Hombourg-Haut</option>
        <option value="QP088002">La Justice - Épinal</option>
        <option value="QP051003">Croix Rouge - Reims</option>
        <option value="QP008002">Ronde Couture - Charleville-Mézières</option>
        <option value="QP008007">Le Lac - Centre Ancien - Sedan</option>
        <option value="QP054002">Gouraincourt - Remparts - Longwy</option>
        <option value="QP068001">Florimont - Bel Air - Colmar</option>
        <option value="QP068009">Quartier De La Gare - Saint-Louis</option>
        <option value="QP057006">Quartier Ouest - Uckange</option>
        <option value="QP057015">Carrière Wehneck - Saint-Avold</option>
        <option value="QP068008">Markstein - La Forêt - Wittenheim</option>
        <option value="QP057024">Les Chênes - Hombourg-Haut</option>
    </datalist>
<div class="buttons is-centered">
<span name="Rechercher" class="button is-link is-rounded is-outlined" @click="search()">Rechercher</span>
<span name="Exporter" class="button is-link is-rounded is-outlined"  @click="exporter()" v-if="etablissements.length>0">Exporter en CSV</span>
<span name="Carte"  class="button is-link is-rounded is-outlined" v-if="etablissements.length>0" @click="geolocaliser();">Géolocaliser</span>
</div>
<div class="is-centered" v-if="afficheCarte">
  <img src="@/assets/spinner.gif" v-if="loading">
  <Map :data="etablissements"  :center="centre" v-if="!loading" :zone="zone"></Map>
</div>
<div id="etabList" v-if="etablissements.length>0" >

<div class="is-centered">{{ etablissements.length }} établissements trouvés</div>
<div class="centered">
<div v-for="etab in etablissements" v-bind:key="etab.ENT_ID_SIREN" class="element">
<strong>{{ etab.ENT_ID_SIREN }} </strong> 
<br>
{{ etab.ENT_ADR_NUMERO_VOIE }}
{{ etab.ENT_ADR_TYPE_VOIE }}
{{ etab.ENT_ADR_ADRESSE }}
{{ etab.ENT_ADR_CODE_POSTAL }}
{{ etab.ENT_ADR_COMMUNE }}
<br>
{{ etab.ENT_ACT_CODE_NAFA_PRINCIPAL }}
<br>
{{ etab.ENT_ACT_ACTIVITE_ARTISANALES_DECLAREES }}
</div>
  </div>
    </div>
  </div>
</template>

<script>
import { ref } from "vue";
import annuaireService from "@/services/annuaireService";
import Map from "@/components/map.vue";

export default {
  name: "Search",
  components: {
    Map,
  },
  async setup() {
    const qpv = ref("");
    const etablissements = ref([]);
    const afficheCarte = ref(false);
    const loading = ref(true);
    const centre = ref([48.8534, 2.3488]);
    const zone = ref("")

    async function search() {
      if (qpv.value != "" ) {
        etablissements.value = [];
        etablissements.value = await annuaireService.getEntreprises(
          qpv.value
        );
      } else {
        console.log("aucune recherche");
      }
    }

    function exporter() {
      let csvContent = "data:text/csv;charset=utf-8,";
      let csvArray = ["siren;qpv;"];

      for (var etab in etablissements.value) {
        csvArray.push(
          etablissements.value[etab].ENT_ID_SIREN+
            ";" +
            qpv.value +
            ";"
        );
      }

      csvContent += csvArray.join("\n");
      const data = encodeURI(csvContent);
      const link = document.createElement("a");
      link.setAttribute("href", data);
      link.setAttribute("download", "export.csv");
      link.click();
    }
    async function geolocaliser() {
       afficheCarte.value = !afficheCarte.value;
       if (afficheCarte.value) {
        loading.value = true;
        //centrer sur la prefecture
        var centreQpv = await annuaireService.getInfoQpv(
          qpv.value
        );
        if (centreQpv) {
          zone.value =  centreQpv[0].geometry
          centre.value = [
            centreQpv[0].properties.YCentre,
            centreQpv[0].properties.XCentre
          ];
        }
        setTimeout(function () {
          loading.value = false;
        }, 2000);
      }
    }
    return {
      search,
      exporter,
      qpv,
      etablissements,
      geolocaliser,
      afficheCarte,
      loading,
      centre,
      zone,
    };
  },
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
h3 {
  margin: 40px 0 0;
}
ul {
  list-style-type: none;
  padding: 0;
}
li {
  display: inline-block;
  margin: 0 10px;
}
a {
  color: #42b983;
}
.element {
  text-align: left;
}
.ismid {
  max-width: 50%;
}
.w90 {
  max-width: 90vw;
}
.centered {
  margin-left: 20%;
}

@media (max-device-width: 768px) and (orientation: portrait) {
  .centered {
    margin-left: 0%;
  }
}
</style>
